"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _dec2, _dec3, _desc, _value, _class;

var _ChildProcessUtilities = require("./ChildProcessUtilities");

var _ChildProcessUtilities2 = _interopRequireDefault(_ChildProcessUtilities);

var _FileSystemUtilities = require("./FileSystemUtilities");

var _FileSystemUtilities2 = _interopRequireDefault(_FileSystemUtilities);

var _dedent = require("dedent");

var _dedent2 = _interopRequireDefault(_dedent);

var _logger = require("./logger");

var _logger2 = _interopRequireDefault(_logger);

var _semver = require("semver");

var _semver2 = _interopRequireDefault(_semver);

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

var CHANGELOG_NAME = "CHANGELOG.md";
var CHANGELOG_HEADER = (0, _dedent2.default)(`# Change Log

  All notable changes to this project will be documented in this file.
  See [standard-version](https://github.com/conventional-changelog/standard-version) for commit guidelines.`);

var RECOMMEND_CLI = require.resolve("conventional-recommended-bump/cli.js");
var CHANGELOG_CLI = require.resolve("conventional-changelog-cli/cli.js");

var ConventionalCommitUtilities = (_dec = _logger2.default.logifySync(), _dec2 = _logger2.default.logifySync(), _dec3 = _logger2.default.logifySync(), (_class = function () {
  function ConventionalCommitUtilities() {
    _classCallCheck(this, ConventionalCommitUtilities);
  }

  _createClass(ConventionalCommitUtilities, null, [{
    key: "recommendVersion",
    value: function recommendVersion(pkg, opts) {
      var name = pkg.name;
      var version = pkg.version;
      var pkgLocation = pkg.location;

      var recommendedBump = _ChildProcessUtilities2.default.execSync(`${RECOMMEND_CLI} -l ${name} --commit-path=${pkgLocation} -p angular`, opts);

      return _semver2.default.inc(version, recommendedBump);
    }
  }, {
    key: "updateChangelog",
    value: function updateChangelog(pkg, opts) {
      var name = pkg.name;
      var pkgLocation = pkg.location;
      var pkgJsonLocation = _path2.default.join(pkgLocation, "package.json");
      var changelogLocation = ConventionalCommitUtilities.changelogLocation(pkg);

      var changelogContents = "";
      if (_FileSystemUtilities2.default.existsSync(changelogLocation)) {
        changelogContents = _FileSystemUtilities2.default.readFileSync(changelogLocation);
      }

      // run conventional-changelog-cli to generate the markdown
      // for the upcoming release.
      var newEntry = _ChildProcessUtilities2.default.execSync(`${CHANGELOG_CLI} -l ${name} --commit-path=${pkgLocation} --pkg=${pkgJsonLocation} -p angular`, opts);

      // CHANGELOG entries start with <a name=, we remove
      // the header if it exists by starting at the first entry.
      if (changelogContents.indexOf("<a name=") !== -1) {
        changelogContents = changelogContents.substring(changelogContents.indexOf("<a name="));
      }

      _FileSystemUtilities2.default.writeFileSync(changelogLocation,
      // only allow 1 \n at end of content.
      (0, _dedent2.default)(`${CHANGELOG_HEADER}

        ${newEntry}

        ${changelogContents}`.replace(/\n+$/, "\n")));
    }
  }, {
    key: "changelogLocation",
    value: function changelogLocation(pkg) {
      return _path2.default.join(pkg.location, CHANGELOG_NAME);
    }
  }]);

  return ConventionalCommitUtilities;
}(), (_applyDecoratedDescriptor(_class, "recommendVersion", [_dec], Object.getOwnPropertyDescriptor(_class, "recommendVersion"), _class), _applyDecoratedDescriptor(_class, "updateChangelog", [_dec2], Object.getOwnPropertyDescriptor(_class, "updateChangelog"), _class), _applyDecoratedDescriptor(_class, "changelogLocation", [_dec3], Object.getOwnPropertyDescriptor(_class, "changelogLocation"), _class)), _class));
exports.default = ConventionalCommitUtilities;
module.exports = exports["default"];