"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = dependencyIsSatisfied;

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

var _readPkg = require("read-pkg");

var _readPkg2 = _interopRequireDefault(_readPkg);

var _semver = require("semver");

var _semver2 = _interopRequireDefault(_semver);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function dependencyIsSatisfied(dir, dependency, needVersion) {
  try {
    var pkg = _readPkg2.default.sync(_path2.default.join(dir, dependency, "package.json"), { normalize: false });
    return _semver2.default.satisfies(pkg.version, needVersion);
  } catch (e) {
    return false;
  }
}
module.exports = exports["default"];